import check
import itertools
from equiv import *

## all_triples_itertools(a_list) produces a list all lists of length three of 
##      distinct elements of a_list
##  all_triples_itertools: (listof Any) -> (listof (listof Any Any Any))
def all_triples_itertools(a_list):
    return list(itertools.combinations(a_list, 3))

three_result = all_triples_itertools([1, 2, 3])
five_result = all_triples_itertools([1, 2, 3, 4, 5])
expected_five_result = [[1, 2, 3], [1, 2, 4], [1, 2, 5], [1, 3, 4], [1, 3, 5], \
                   [1, 4, 5], [2, 3, 4], [2, 3, 5], [2, 4, 5], [3, 4, 5]]
check.expect("All triples for zero elements", all_triples_itertools([]), [])
check.expect("All triples for one element", all_triples_itertools([1]), [])
check.expect("All triples for two elements", all_triples_itertools([1, 2]), [])
check.expect("All triples for three elements", \
             equiv_lol(three_result, [[1, 2, 3]]), True)
check.expect("All triples same using itertools", \
             equiv_lol(five_result, expected_five_result), True)

