from graphs import *

## tour_cost(graph, perm) produces the sum of the cost of the edges in
##      the tour defined by perm (an ordering of the vertex IDs)
## tour_cost: Graph (listof Str) -> Int
## Requires: graph has an edge between each pair of vertices
##           perm contains distinct IDs of vertices in graph
def tour_cost(graph, perm):
    total = 0
    length = len(perm)
    for index in range(length-1):
        total = total + graph.edge_weight(perm[index], perm[index+1])
    total = total + graph.edge_weight(perm[length-1], perm[0])
    return total

## tour_cost_alt(graph, perm) produces the sum of the cost of the edges in
##      the tour defined by perm (an ordering of the vertex IDs)
## Requires: graph has edges between each pair of vertices
##           perm contains distinct IDs of vertices in graph
## tour_cost_alt: Graph (listof Str) -> Int
def tour_cost_alt(graph, perm):
    total = 0
    length = len(perm)
    for index in range(length):
        total = total + graph.edge_weight(perm[index], perm[(index+1) % length])
    return total







        

