import itertools
from sess1q7tourcost import *
from graphs import *

## exhaustive_tsp(graph) produces the lowest cost tour of all vertices in graph
##                   as a list containing IDs of vertices in order
## exhaustive_tsp: Graph -> (listof Str)
## Requires: graph has an edge between each pair of vertices
def exhaustive_tsp(graph):
    vertices = graph.vertices()
    perms = itertools.permutations(vertices,len(vertices))
    all_orders = list(perms)
    min_cost = tour_cost(graph, list(all_orders[0]))
    best_order = list(all_orders[0])
    for order in all_orders[1:]:
        new_cost = tour_cost(graph, list(order))
        if new_cost < min_cost:
            min_cost = new_cost
            best_order = list(order)
    return best_order


        

